package de.frajul.endlessroll.entities.shapes;

import android.support.annotation.DrawableRes;
import android.support.annotation.StringRes;

import de.frajul.endlessroll.R;
import de.frajul.endlessroll.entities.textures.Texture;
import de.frajul.endlessroll.entities.textures.TexturePack;

/**
 * Created by Julian on 22.10.2017.
 */

public enum PlayerShape {
    BALL(R.string.playershape_name_ball, R.drawable.playershapes_ball), CLOCK(R.string.playershape_name_clock,
            R.drawable.playershapes_clock), HYPNO_SPIRAL(R.string.playershape_name_hypno_spiral,
            R.drawable.playershapes_hypno_spiral), PACMAN(R.string.playershape_name_pacman,
            R.drawable.playershapes_pacman), SMILEY(R.string.playershape_name_smiley,
            R.drawable.playershapes_smiley);

    @StringRes
    private int nameId;
    @DrawableRes
    private int drawableId;

    private Texture texture;

    PlayerShape(@StringRes int nameId, @DrawableRes int drawableId) {
        this.nameId = nameId;
        this.drawableId = drawableId;
    }

    public static void loadAllTextures(TexturePack texturePack) {
        for (PlayerShape playerShape : values())
            playerShape.loadTexture(texturePack);
    }

    private void loadTexture(TexturePack texturePack) {
        if (drawableId == -1)
            return;
        texture = texturePack.loadTexture(drawableId);
    }

    @StringRes
    public int getNameId() {
        return nameId;
    }

    @DrawableRes
    public int getDrawableId() {
        return drawableId;
    }

    public Texture getTexture() {
        return texture;
    }
}
